回溯算法

39. 组合总和

思路: 题意是给 定 一 个 无 重 复 元 素 的 数 组 candidates 和 一 个 目 标 数 target , 找 出 candidates 中所有可以使数字和为 target 的组合。注意一点数组里的元素可以无限次取。做法是以当前数组中的元素往后dfs。

class Solution {
    private void dfs(List<List<Integer>> res,List<Integer>tmp,int []a, int target, int cur){
        if(target==0) {res.add(new ArrayList<>(tmp)); return;}
        for(int i=cur; i<a.length ; i++){
            if(a[i]>target) continue;
            tmp.add(a[i]);
            dfs(res,tmp,a,target-a[i],i);
            tmp.remove(tmp.size()-1);
        }
    }
    public List<List<Integer>> combinationSum(int[] candidates, int target) {
        List<List<Integer>> res = new ArrayList<>();
        dfs(res,new ArrayList<Integer>(),candidates,target,0);
        return res;
    }
}

40. 组合总和 II

题意:数组里的元素只能读一次。解题思想还是一样的,我们要做的是怎么过滤掉重复的,首 先 可 以 对 原 数 组 进 行 排 序 , 排 序 之 后 相 同 的 肯 定 是 挨 着 的 , if ( candidates [i] == candidates [i - 1] ) 我 们 就 过 滤 掉 candidates [i] 。
代码:

class Solution {
    private void dfs(List<List<Integer>> res,List<Integer> tmp, int a[], int target,int cur){
        if(target==0){res.add(new ArrayList<Integer>(tmp)); return;}
        for(int i=cur;i<a.length;i++){
            if(target<a[i]) continue;
            if(i>cur&&a[i]==a[i-1]) continue;
            tmp.add(a[i]);
            dfs(res,tmp,a,target-a[i],i+1);
            tmp.remove(tmp.size()-1);
        }
    }
    public List<List<Integer>> combinationSum2(int[] candidates, int target) {
        Arrays.sort(candidates);
        List<List<Integer>> res = new ArrayList<>();
        dfs(res,new ArrayList<>(),candidates,target,0);
        return res;
    }
}

216. 组合总和 III

思路:题意是给定[k,n], 从1-9中选出k个数字,他们的和等于n。做法是枚举1-9的数字进行深搜。这里要注意JAVA的深拷贝和浅拷贝。
代码:

class Solution {
    private void dfs(List<List<Integer>> res, List<Integer> tmp, int cur, int n, int k){
       //如果候选数字的个数达到k并且和是n(n每次遇到新元素减去直到为0)
        if(tmp.size()==k) {
            if(n==0) {res.add(new ArrayList<>(tmp));}
            return;
        }
        //每次tmp添加当前元素,然后回溯,remove掉队尾元素
        for(int i=cur;i<=9;i++){
            tmp.add(i);
            dfs(res,tmp,i+1,n-i,k);
            tmp.remove(tmp.size()-1);
        }
    }
    public List<List<Integer>> combinationSum3(int k, int n) {
        List<List<Integer>> res = new ArrayList<>();
        //从1开始枚举,1-9 接着2-9 接着3-9 。。。
        dfs(res,new ArrayList<>(),1,n,k);
        return res;
    }
}

进一步思考:如果1-9数字可以重复呢? 其实只需要在递归中i+1 -->i

面试题 08.12. 八皇后

思路:输入n 代表n*n的棋盘,求摆置皇后个所有可能性。
代码:

class Solution {
    public List<List<String>> solveNQueens(int n) {
      //初始化棋盘
        char[][] chess = new char[n][n];
        for(int i=0; i<n;i++){
            for(int j=0; j<n; j++){
                chess[i][j] = '.';
            }
        }
    //因为leetcode输出是List<List<String>>结构,而棋盘我们设置的是二维char数组,因此需要把结果进行转换
        List<List<String>> res = new ArrayList<>();
        solve(res,chess,0);
        return res;
    }
    //根据每行进行递归,如果当前行数等于棋盘长度则递归终止。每次按列进行回溯探测。
    private void solve(List<List<String>> res, char[][] chess,int row){
        if(row == chess.length) {res.add(array2List(chess));return;}
        for(int col=0;col<chess[0].length;col++){
            if(valid(chess,row,col)){
                chess[row][col] = 'Q';
                solve(res,chess,row+1);
                chess[row][col] = '.';
            }
        }
    }
    //检查当前落下棋子位置的正确性,即上面,左上,右上是否已经存在Queue
    private boolean valid(char[][]chess,int row, int col){
        //up
        for(int i=0;i<row;i++){if(chess[i][col]=='Q') return false;}
        //up-right
        for(int i=row-1,j=col+1;i>=0&&j<chess[0].length;i--,j++){if(chess[i][j]=='Q') return false;}
        //up-left
        for(int i=row-1,j=col-1;i>=0&&j>=0;i--,j--){if(chess[i][j]=='Q') return false;}
        return true;
    }
    List<String>array2List(char[][]chess){
        List<String> target = new ArrayList<>();
        for(int i=0;i<chess.length;i++){target.add(new String(chess[i]));}
        return target;
    }
}
  • 测试下假如就使用List<char[][]>
class Solution {
     private boolean valid(char[][]chess,int row, int col){
        //up
        for(int i=0;i<row;i++){if(chess[i][col]=='Q') return false;}
        //up-right
        for(int i=row-1,j=col+1;i>=0&&j<chess[0].length;i--,j++){if(chess[i][j]=='Q') return false;}
        //up-left
        for(int i=row-1,j=col-1;i>=0&&j>=0;i--,j--){if(chess[i][j]=='Q') return false;}
        return true;
    }
    private void solve(char[][] chess, List<char[][]>res, int row){
        if(row==chess.length) {
            char[][]tmp = new char[chess.length][chess[0].length];
            for(int i=0;i<chess.length;i++){
                for(int j=0;j<chess[0].length;j++){
                    tmp[i][j] = chess[i][j];
                }
            }
            res.add(tmp);
        }
        for(int col=0;col<chess[0].length;col++){
            if(valid(chess,row,col)){
                chess[row][col] = 'Q';
                solve(chess,res,row+1);
                chess[row][col] = '.';
            }
        }
    }
     public List<List<String>> solveNQueens(int n) {
         List<List<String>> res = new ArrayList<>();
         solveNQueens1(n);
         return res;
     }
    public List<char[][]> solveNQueens1(int n) {
        char[][] chess = new char[n][n];
        List<char[][]> res = new ArrayList<>();
        for(int i=0; i<n;i++){
            for(int j=0; j<n; j++){
                chess[i][j] = '.';
            }
        }
        solve(chess,res,0);
        for(char[][] each: res){
            for(int i=0;i<each.length;i++){
                for(int j=0;j<each[0].length;j++){
                    System.out.print(each[i][j]+" ");
                }
                System.out.println();
            }
            System.out.println("==========");
        }
        return res;
    }
}

46. 全排列

思路:题意是要求一组没有重复数字的全排列。在回溯的时候判断下tmp里面是否包含之前的数字即可。
代码:

class Solution {
    private void dfs(List<List<Integer>> res, List<Integer> tmp, int []nums){
        if(tmp.size()==nums.length){res.add(new ArrayList<>(tmp)); return;}
        for(int i=0;i<nums.length;i++){
            if(tmp.contains(nums[i])==false){
                tmp.add(nums[i]);
                dfs(res,tmp,nums);
                tmp.remove(tmp.size()-1);
            }
        }
    }
    public List<List<Integer>> permute(int[] nums) {
        List<List<Integer>> res = new ArrayList<>();
        dfs(res,new ArrayList<>(),nums);
        return res;
    }
}

78. 子集

思路:求一组整数数组的子集。

class Solution {
    private void dfs(List<List<Integer>> res,List<Integer> tmp,int[]nums,int cur){
        res.add(new ArrayList<>(tmp));
        for(int i=cur;i<nums.length;i++){
            tmp.add(nums[i]);
            dfs(res,tmp,nums,i+1);
            tmp.remove(tmp.size()-1);
        }
    }
    public List<List<Integer>> subsets(int[] nums) {
        List<List<Integer>> res = new ArrayList<>();
        dfs(res,new ArrayList<>(),nums,0);
        return res;
    }
}

1219. 黄金矿工

思路:题意是n*m的金矿,值为0不可开采。工人可以从任意单元格进入从上下左右四个方向进行开采。 遍历这个二维数组,从每个单元格出发深搜找出从该点出发的最大值。
代码:

class Solution {
    private int dfs(int x, int y,int [][]grid){
        if(x<0||x>=grid.length||y<0||y>=grid[0].length||grid[x][y]==0) return 0;
        //从该点出发深度搜索,为了防止重复搜索该点的值先置为0,dfs后再还原
        int tmp = grid[x][y];
        int max = Integer.MIN_VALUE;
        grid[x][y] = 0;
        int up = dfs(x,y-1,grid);
        int down = dfs(x,y+1,grid);
        int left = dfs(x-1,y,grid);
        int right = dfs(x+1,y,grid);
        max = Math.max(Math.max(Math.max(up,down),left),right);
        grid[x][y] = tmp;
        return grid[x][y]+max;

    }
    public int getMaximumGold(int[][] grid) {
        if(grid.length==0) return 0;
        int rows = grid.length;
        int cols = grid[0].length;
        int res = Integer.MIN_VALUE;
        for(int i=0;i<rows;i++){
            for(int j=0;j<cols;j++){
                res = Math.max(res,dfs(i,j,grid));
            }
        }
        return res;
    }
}

路径和问题

    1. 寻找路径和是否等于目标值
      思路:为了节省一个变量直接用sum减去当前的节点值。当前为空直接返回false,如果已经遍历到叶子节点则比较root.val==sum;否则递归左子树和右子树。
      代码:
/**
 * Definition for a binary tree node.
 * public class TreeNode {
 *     int val;
 *     TreeNode left;
 *     TreeNode right;
 *     TreeNode(int x) { val = x; }
 * }
 */
class Solution {
    public boolean hasPathSum(TreeNode root, int sum) {
        if(root==null)  return false;
        if(root.left==null&&root.right==null) return sum==root.val;
        return hasPathSum(root.left, sum-root.val)||hasPathSum(root.right, sum-root.val);
    }
}
    1. 路径总和 II
      思路:和上面基础题的思路一致采用回溯+dfs,回溯每次要remove掉新添加进去的元素。
/**
 * Definition for a binary tree node.
 * public class TreeNode {
 *     int val;
 *     TreeNode left;
 *     TreeNode right;
 *     TreeNode(int x) { val = x; }
 * }
 */
class Solution {
    private void dfs(TreeNode root, int targetSum, List<List<Integer>> res,List<Integer> tmp){
        if(root.left==null&&root.right==null&&root.val==targetSum){tmp.add(root.val);res.add(new ArrayList<>(tmp));tmp.remove(tmp.size()-1);return;}
        tmp.add(root.val);
        if(root.left!=null) dfs(root.left,targetSum-root.val,res,tmp);
        tmp.remove(tmp.size()-1);
        tmp.add(root.val);
        if(root.right!=null) dfs(root.right,targetSum-root.val,res,tmp);
        tmp.remove(tmp.size()-1);

    }
    public List<List<Integer>> pathSum(TreeNode root, int sum) {
        List<List<Integer>> res = new ArrayList<>();
        if(root==null) return res;
        dfs(root,sum,res,new ArrayList<>());
        return  res;
    }
}

剑指 Offer 12. 矩阵中的路径

思路:从board的每个点从四周进行dfs搜索直到word的最后一个字符搜索完
代码:

class Solution {
    private boolean dfs(int x,int y,char[][]board,char[] words,int index){
    //如果越界或者当前的字符和棋盘当前的字符不等,返回false
        if(x<0||x>=board.length||y<0||y>=board[0].length||board[x][y]!=words[index])   return false;
        //如果word全部在棋盘找到返回true
        if(index==words.length-1) return true;
        //保留现场
        char tmp = board[x][y];
        board[x][y] = '#';
        //向上下左右dfs
        boolean res= dfs(x-1,y,board,words,index+1)||dfs(x+1,y,board,words,index+1)||dfs(x,y-1,board,words,index+1)||dfs(x,y+1,board,words,index+1);
        //还原现场
        board[x][y] = tmp;
        return res;

    }
    public boolean exist(char[][] board, String word) {
        char[] words = word.toCharArray();
        for(int i=0; i<board.length; i++){
            for(int j=0; j<board[0].length; j++){
                if(dfs(i,j,board,words,0))  return true;
            }
        }
        return false;
    }
}
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值